/*
 * file: XxColor.cpp
 *
 * This file is part of the XxWinLib library which is developed to support
 * the development of NetStreamer. This file is distributed under the
 * GNU GENERAL PUBLIC LICENSE, see the accompanying COPYING file.
 *
 * Copyright (C) 1997 Rolf Fokkens
 *
 */

#include <iostream.h>
#include "XxColor.h"

XxColor::XxColor (const XxColor &Color)
    : XxCore (0)
{
    pixel = Color.pixel;
};

void XxColor::Constr (int Red, int Green, int Blue)
{
    XColor color;

    color.red   = Red;
    color.green = Green;
    color.blue  = Blue;

    XAllocColor
    ( GetDisplay ()
    , DefaultColormap (GetDisplay (), GetScreen ())
    , &color
    );
    pixel = color.pixel;
};

XxColor::XxColor (int Red, int Green, int Blue)
    : XxCore (0)
{
    Constr (Red, Green, Blue);
};

XxColor::XxColor (void)
    : XxCore (0)
{
    Constr (0, 0, 0);
};

XxColor &XxColor::operator= (const XxColor &Color)
{
    pixel = Color.pixel;

    return *this;
};

const XxColor XxBlack   (0x0000,0x0000,0x0000);
const XxColor XxGray1   (0x2000,0x2000,0x2000);
const XxColor XxGray2   (0x4000,0x4000,0x4000);
const XxColor XxGray3   (0x6000,0x6000,0x6000);
const XxColor XxGray4   (0x8000,0x8000,0x8000);
const XxColor XxGray5   (0xA000,0xA000,0xA000);
const XxColor XxGray6   (0xC000,0xC000,0xC000);
const XxColor XxGray7   (0xE000,0xE000,0xE000);
const XxColor XxWhite   (0xffff,0xffff,0xffff);

const XxColor XxRed1    (0x4000,0x0000,0x0000);
const XxColor XxRed2    (0x8000,0x0000,0x0000);
const XxColor XxRed3    (0xC000,0x0000,0x0000);
const XxColor XxRed4    (0xffff,0x0000,0x0000);

const XxColor XxYellow1 (0x4000,0x4000,0x0000);
const XxColor XxYellow2 (0x8000,0x8000,0x0000);
const XxColor XxYellow3 (0xC000,0xC000,0x0000);
const XxColor XxYellow4 (0xffff,0xffff,0x0000);

const XxColor XxGreen1  (0x0000,0x4000,0x0000);
const XxColor XxGreen2  (0x0000,0x8000,0x0000);
const XxColor XxGreen3  (0x0000,0xC000,0x0000);
const XxColor XxGreen4  (0x0000,0xffff,0x0000);

const XxColor XxBlue1   (0x0000,0x0000,0x4000);
const XxColor XxBlue2   (0x0000,0x0000,0x8000);
const XxColor XxBlue3   (0x0000,0x0000,0xC000);
const XxColor XxBlue4   (0x0000,0x0000,0xffff);
